using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_CRM._0_Modelos;
using Exferia_CRM.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_CRM._3_Vistas.Listados
{
    public class ABS_Listado_CRMS_TrabajosRealizados_Filtros_Internos : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();
        private INTERNO_ValoresGenerales_Modelo g_mdl_INTERNO_ValoresGenerales_Modelo = null;
        //Constructor
        public ABS_Listado_CRMS_TrabajosRealizados_Filtros_Internos(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo)
        {
            g_mdl_INTERNO_ValoresGenerales_Modelo = _mdl_INTERNO_ValoresGenerales_Modelo;

            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idClientePotencial), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idClientePotencial), "idClientePotencial", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idEmpleado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idEmpleado), "idEmpleado", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idMotivoNoVisita), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idMotivoNoVisita), "idMotivoNoVisita", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idTerminal), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idTerminal), "idTerminal", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.TipoAccion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.TipoAccion), "Tipo de Acción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 120, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.fechaHora), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.fechaHora), "Fecha y Hora", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 130, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.Duracion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.Duracion), "Duración (m.)", Enumerados.G_ENUM_TIPOSDATOS.LONG, false, 80, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.trabajoRealizado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.trabajoRealizado), "Trabajo Realizado", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, true, true, false, "", null));
            
            // ClientePotencial
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_CLIENTEPOTENCIAL = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idClientePotencial), nameof(CRM_ClientesPotenciales), nameof(CRM_ClientesPotenciales.id), nameof(CRM_ClientesPotenciales.codigo), nameof(CRM_ClientesPotenciales.nombreComercial), nameof(CRM_ClientesPotenciales.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.ClientePotencial), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.ClientePotencial), "Cliente Potencial", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_CLIENTEPOTENCIAL));

            //Terminal
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_TERMINAL = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idTerminal), nameof(CRM_Terminales), nameof(CRM_Terminales.id), nameof(CRM_Terminales.codigo), nameof(CRM_Terminales.descripcion), nameof(CRM_Terminales.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.Terminal), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.Terminal), "Terminal", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_TERMINAL));

            //Empleado
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPLEADO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idEmpleado), nameof(MAE_Empleados), nameof(MAE_Empleados.id), nameof(MAE_Empleados.codigo), nameof(MAE_Empleados.nombre), nameof(MAE_Empleados.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.Empleado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.Empleado), "Empleado", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPLEADO));

            //MotivoNoVisita
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_MOTIVONOVISITA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.idMotivoNoVisita), nameof(CRM_MotivosNoVisita), nameof(CRM_MotivosNoVisita.id), nameof(CRM_MotivosNoVisita.codigo), nameof(CRM_MotivosNoVisita.descripcion), nameof(CRM_MotivosNoVisita.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.MotivoNoVisita), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.MotivoNoVisita), "Motivo No Visita", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_MOTIVONOVISITA));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CRMS_TRABAJOSREALIZADOS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_CRMS_TRABAJOSREALIZADOS;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CRMS_TrabajosRealizados_Listado_Modelo.fechaHora);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
